<?php


namespace NL\NlMenubuilder\Domain\Model;


use TYPO3\CMS\Extbase\Persistence\ObjectStorage;

trait MenuTrait
{
    /**
     * Returns the title
     *
     * @return string $title
     */
    public function getTitle(): string
    {
        return $this->title;
    }

    /**
     * Returns the items
     *
     * @return ObjectStorage<MenuItem> items
     */
    public function getItems(): ?ObjectStorage
    {
        return $this->items;
    }

    /**
     * @return array
     */
    public function getPageItems(): array
    {
        return $this->getItemsByType(MenuItem::TYPE_PAGE);
    }

    /**
     * @return array
     */
    public function getLinkItems(): array
    {
        return $this->getItemsByType(MenuItem::TYPE_LINK);
    }

    /**
     * @return array
     */
    public function getContentItems(): array
    {
        return $this->getItemsByType(MenuItem::TYPE_CONTENT);
    }

    /**
     * @return array
     */
    public function getSubmenuItems(): array
    {
        return $this->getItemsByType(MenuItem::TYPE_SUBMENU);
    }

    /**
     * @param int $type
     * @return array
     */
    public function getItemsByType(int $type): array
    {
        if ($items = $this->getItems()) {

            return array_filter(
                $items->toArray(),
                function ($item) use($type) {

                    /** @var MenuItem $item */
                    return $item->getType() === $type;
                }
            );
        }

        return [];
    }
}
